﻿using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace HeuristicLab.Tests.Expressions
{
    [TestClass]
    public class IntegerExpressionTests : InterpreterTest
    {
        [TestMethod]
        public void TestAdd()
        {
            interpreter.Interpret("( 5 5 INTEGER.+ )");

            Assert.AreEqual(10, interpreter.IntegerStack.Top);
            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
            Assert.IsTrue(interpreter.NameStack.IsEmpty);
            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
        }

        [TestMethod]
        public void TestSubtract()
        {
            interpreter.Interpret("( 10 5 INTEGER.- )");

            Assert.AreEqual(5, interpreter.IntegerStack.Top);
            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
            Assert.IsTrue(interpreter.NameStack.IsEmpty);
            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
        }
    }
}
